/* $Id: mapwind.c 1.1 1994/02/20 17:43:36 ulrich Exp $ */
/*
 * X library function XMapWindow.
 */
#include "Xlibemu.h"

int
XMapWindow (Display* dpy, Window window)
{
  XEvent xe;

  if (0 == _WCheckWindow (dpy, window, X_MapWindow))
    return 0;

  if (window->mapped)
    return 1;

  if (window->override_redirect == False
      && window->parent != NULL
      && window->parent->event_mask & SubstructureRedirectMask) {
    xe.xmaprequest.type = MapRequest;
    xe.xmaprequest.send_event = False;
    xe.xmaprequest.parent = window->parent;
    xe.xmaprequest.window = window;
    if (_WRedirectEvent (dpy, &xe))
      return 0;
  }

  _WMapWindow (dpy, window);

  if (window->event_mask & StructureNotifyMask) {
    xe.xmap.type = MapNotify;
    xe.xmap.send_event = 0;
    xe.xmap.display = dpy;
    xe.xmap.event = window;
    xe.xmap.window = window;
    xe.xmap.override_redirect = window->override_redirect;
    _WDispatchEvent (&xe);
  }
  if (window->parent &&
      window->parent->event_mask & SubstructureNotifyMask) {
    xe.xmap.type = MapNotify;
    xe.xmap.send_event= 0;
    xe.xmap.display = dpy;
    xe.xmap.event = window->parent;
    xe.xmap.window = window;
    xe.xmap.override_redirect = window->override_redirect;
    _WDispatchEvent (&xe);
  }
  return 1;
}
